diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/default-channel-scheduler.h ns-3.38/src/wave/model/default-channel-scheduler.h
--- ns-3.37/src/wave/model/default-channel-scheduler.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/default-channel-scheduler.h	2023-03-16 20:54:23.844869400 -0700
@@ -49,7 +49,7 @@
      * \param channelNumber the specified channel number
      * \return  the type of current assigned channel access for the specific channel.
      */
-    enum ChannelAccess GetAssignedAccessType(uint32_t channelNumber) const override;
+    ChannelAccess GetAssignedAccessType(uint32_t channelNumber) const override;
 
     /**
      * Notify CCH slot start
@@ -126,10 +126,10 @@
      *   is extended access, extends is the number of extends access.
      *  when m_channelAccess is DefaultCchAccess, m_channelNumber is CCH.
      */
-    uint32_t m_channelNumber;           ///< channel number
-    uint32_t m_extend;                  ///< extend
-    EventId m_extendEvent;              ///< extend event
-    enum ChannelAccess m_channelAccess; ///< channel access
+    uint32_t m_channelNumber;      ///< channel number
+    uint32_t m_extend;             ///< extend
+    EventId m_extendEvent;         ///< extend event
+    ChannelAccess m_channelAccess; ///< channel access
 
     EventId m_waitEvent;          ///< wait event
     uint32_t m_waitChannelNumber; ///< wait channel number
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/higher-tx-tag.cc ns-3.38/src/wave/model/higher-tx-tag.cc
--- ns-3.37/src/wave/model/higher-tx-tag.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/higher-tx-tag.cc	2023-03-16 20:54:23.844869400 -0700
@@ -55,6 +55,9 @@
 
 HigherLayerTxVectorTag::HigherLayerTxVectorTag(WifiTxVector txVector, bool adaptable)
     : m_txVector(txVector),
+      m_mode(txVector.GetMode()),
+      m_preamble(txVector.GetPreambleType()),
+      m_channelWidth(txVector.GetChannelWidth()),
       m_adaptable(adaptable)
 {
     NS_LOG_FUNCTION(this);
@@ -80,14 +83,16 @@
 HigherLayerTxVectorTag::GetSerializedSize() const
 {
     NS_LOG_FUNCTION(this);
-    return (sizeof(WifiTxVector) + 1);
+    return (sizeof(WifiMode) + 1 + 2 + 1);
 }
 
 void
 HigherLayerTxVectorTag::Serialize(TagBuffer i) const
 {
     NS_LOG_FUNCTION(this << &i);
-    i.Write((uint8_t*)&m_txVector, sizeof(WifiTxVector));
+    i.Write((uint8_t*)&m_mode, sizeof(WifiMode));
+    i.WriteU8(static_cast<uint8_t>(m_preamble));
+    i.WriteU16(m_channelWidth);
     i.WriteU8(static_cast<uint8_t>(m_adaptable));
 }
 
@@ -95,8 +100,13 @@
 HigherLayerTxVectorTag::Deserialize(TagBuffer i)
 {
     NS_LOG_FUNCTION(this << &i);
-    i.Read((uint8_t*)&m_txVector, sizeof(WifiTxVector));
+    i.Read((uint8_t*)&m_mode, sizeof(WifiMode));
+    m_preamble = static_cast<WifiPreamble>(i.ReadU8());
+    m_channelWidth = i.ReadU16();
     m_adaptable = i.ReadU8();
+    m_txVector.SetMode(m_mode);
+    m_txVector.SetPreambleType(m_preamble);
+    m_txVector.SetChannelWidth(m_channelWidth);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/higher-tx-tag.h ns-3.38/src/wave/model/higher-tx-tag.h
--- ns-3.37/src/wave/model/higher-tx-tag.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/higher-tx-tag.h	2023-03-16 20:54:23.844869400 -0700
@@ -78,6 +78,9 @@
 
   private:
     WifiTxVector m_txVector; ///< transmit vector
+    WifiMode m_mode;         ///< wifi mode
+    WifiPreamble m_preamble; ///< wifi preamble
+    uint16_t m_channelWidth; ///< channel width in MHz
     bool m_adaptable;        ///< adaptable
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/ocb-wifi-mac.cc ns-3.38/src/wave/model/ocb-wifi-mac.cc
--- ns-3.37/src/wave/model/ocb-wifi-mac.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/ocb-wifi-mac.cc	2023-03-16 20:54:23.844869400 -0700
@@ -342,7 +342,7 @@
 }
 
 void
-OcbWifiMac::ConfigureEdca(uint32_t cwmin, uint32_t cwmax, uint32_t aifsn, enum AcIndex ac)
+OcbWifiMac::ConfigureEdca(uint32_t cwmin, uint32_t cwmax, uint32_t aifsn, AcIndex ac)
 {
     NS_LOG_FUNCTION(this << cwmin << cwmax << aifsn << ac);
     Ptr<Txop> dcf;
@@ -413,7 +413,7 @@
 }
 
 void
-OcbWifiMac::ConfigureStandard(enum WifiStandard standard)
+OcbWifiMac::ConfigureStandard(WifiStandard standard)
 {
     NS_LOG_FUNCTION(this << standard);
     NS_ASSERT(standard == WIFI_STANDARD_80211p);
@@ -488,7 +488,7 @@
 }
 
 void
-OcbWifiMac::CancleTx(enum AcIndex ac)
+OcbWifiMac::CancleTx(AcIndex ac)
 {
     NS_LOG_FUNCTION(this << ac);
     Ptr<QosTxop> queue = GetQosTxop(ac);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/ocb-wifi-mac.h ns-3.38/src/wave/model/ocb-wifi-mac.h
--- ns-3.37/src/wave/model/ocb-wifi-mac.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/ocb-wifi-mac.h	2023-03-16 20:54:23.844869400 -0700
@@ -63,13 +63,13 @@
      * \param oi Organization Identifier field
      * see 7.3.1.31 Organization Identifier field and 10.3.29 Vendor-specific action
      *
-     * management information can be transmitted over vender specific action frame.
+     * management information can be transmitted over vendor specific action frame.
      * This will be mainly called by IEEE Std 1609.4 to send WSA from IEEE Std 1609.3
      */
     void SendVsc(Ptr<Packet> vsc, Mac48Address peer, OrganizationIdentifier oi);
     /**
      * \param oi Organization Identifier
-     * \param cb callback to invoke whenever a vender specific action frame has been received and
+     * \param cb callback to invoke whenever a vendor specific action frame has been received and
      * must be forwarded to the higher layers. every node shall register first if it wants to
      * receive specific vendor specific content.
      */
@@ -136,7 +136,7 @@
      *
      * configure EDCA queue parameters
      */
-    void ConfigureEdca(uint32_t cwmin, uint32_t cwmax, uint32_t aifsn, enum AcIndex ac);
+    void ConfigureEdca(uint32_t cwmin, uint32_t cwmax, uint32_t aifsn, AcIndex ac);
 
     // below six public methods are used for MAC extension defined in IEEE 1609.4
     /**
@@ -169,7 +169,7 @@
      * To support MAC extension for multiple channel operation,
      * Cancel transmit operation for internal queue associated with a specified Access Category.
      */
-    void CancleTx(enum AcIndex ac);
+    void CancleTx(AcIndex ac);
     /**
      * To support MAC extension for multiple channel operation,
      * Reset current MAC entity and flush its internal queues.
@@ -183,7 +183,7 @@
     void SetWifiPhy(Ptr<WifiPhy> phy);
 
     // Inherited from base class
-    void ConfigureStandard(enum WifiStandard standard) override;
+    void ConfigureStandard(WifiStandard standard) override;
 
   protected:
     void DoDispose() override;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/vendor-specific-action.cc ns-3.38/src/wave/model/vendor-specific-action.cc
--- ns-3.37/src/wave/model/vendor-specific-action.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/vendor-specific-action.cc	2023-03-16 20:54:23.844869400 -0700
@@ -107,7 +107,7 @@
 }
 
 void
-OrganizationIdentifier::SetType(enum OrganizationIdentifierType type)
+OrganizationIdentifier::SetType(OrganizationIdentifierType type)
 {
     NS_LOG_FUNCTION(this);
     m_type = type;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/vendor-specific-action.h ns-3.38/src/wave/model/vendor-specific-action.h
--- ns-3.37/src/wave/model/vendor-specific-action.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/vendor-specific-action.h	2023-03-16 20:54:23.844869400 -0700
@@ -89,11 +89,11 @@
     /**
      * \param type set the type of current OrganizationIdentifier
      */
-    void SetType(enum OrganizationIdentifierType type);
+    void SetType(OrganizationIdentifierType type);
     /**
      * \returns whether this OrganizationIdentifier is OUI24 or OUI36.
      */
-    enum OrganizationIdentifierType GetType() const;
+    OrganizationIdentifierType GetType() const;
 
     // below methods will be called by VendorSpecificActionHeader
     /**
@@ -120,8 +120,8 @@
     friend std::ostream& operator<<(std::ostream& os, const OrganizationIdentifier& oi);
     friend std::istream& operator>>(std::istream& is, const OrganizationIdentifier& oi);
 
-    enum OrganizationIdentifierType m_type; ///< OI type
-    uint8_t m_oi[5];                        ///< organization identifier
+    OrganizationIdentifierType m_type; ///< OI type
+    uint8_t m_oi[5];                   ///< organization identifier
 };
 
 ATTRIBUTE_HELPER_HEADER(OrganizationIdentifier);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/vsa-manager.cc ns-3.38/src/wave/model/vsa-manager.cc
--- ns-3.37/src/wave/model/vsa-manager.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/vsa-manager.cc	2023-03-16 20:54:23.844869400 -0700
@@ -124,7 +124,7 @@
 }
 
 void
-VsaManager::DoSendVsa(enum VsaTransmitInterval interval,
+VsaManager::DoSendVsa(VsaTransmitInterval interval,
                       uint32_t channel,
                       Ptr<Packet> vsc,
                       OrganizationIdentifier oi,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/vsa-manager.h ns-3.38/src/wave/model/vsa-manager.h
--- ns-3.37/src/wave/model/vsa-manager.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/vsa-manager.h	2023-03-16 20:54:23.844869400 -0700
@@ -62,13 +62,13 @@
  */
 struct VsaInfo
 {
-    Mac48Address peer;                     ///< peer
-    OrganizationIdentifier oi;             ///< OI
-    uint8_t managementId;                  ///< management ID
-    Ptr<Packet> vsc;                       ///< VSC
-    uint32_t channelNumber;                ///< channel number
-    uint8_t repeatRate;                    ///< repeat rate
-    enum VsaTransmitInterval sendInterval; ///< send interval
+    Mac48Address peer;                ///< peer
+    OrganizationIdentifier oi;        ///< OI
+    uint8_t managementId;             ///< management ID
+    Ptr<Packet> vsc;                  ///< VSC
+    uint32_t channelNumber;           ///< channel number
+    uint8_t repeatRate;               ///< repeat rate
+    VsaTransmitInterval sendInterval; ///< send interval
 
     /**
      * Initializer
@@ -86,7 +86,7 @@
             Ptr<Packet> vscPacket,
             uint32_t channel,
             uint8_t repeat,
-            enum VsaTransmitInterval interval)
+            VsaTransmitInterval interval)
         : peer(peer),
           oi(identifier),
           managementId(manageId),
@@ -183,13 +183,13 @@
     /// VsaWork structure
     struct VsaWork
     {
-        Mac48Address peer;                     ///< peer
-        OrganizationIdentifier oi;             ///< OI
-        Ptr<Packet> vsc;                       ///< VSC
-        uint32_t channelNumber;                ///< channel number
-        enum VsaTransmitInterval sentInterval; ///< VSA transmit interval
-        Time repeatPeriod;                     ///< repeat period
-        EventId repeat;                        ///< repeat ID
+        Mac48Address peer;                ///< peer
+        OrganizationIdentifier oi;        ///< OI
+        Ptr<Packet> vsc;                  ///< VSC
+        uint32_t channelNumber;           ///< channel number
+        VsaTransmitInterval sentInterval; ///< VSA transmit interval
+        Time repeatPeriod;                ///< repeat period
+        EventId repeat;                   ///< repeat ID
     };
 
     /**
@@ -205,7 +205,7 @@
      * \param oi the Organization Identifier for VSA frame
      * \param peer the destination address
      */
-    void DoSendVsa(enum VsaTransmitInterval interval,
+    void DoSendVsa(VsaTransmitInterval interval,
                    uint32_t channel,
                    Ptr<Packet> vsc,
                    OrganizationIdentifier oi,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/wave-net-device.cc ns-3.38/src/wave/model/wave-net-device.cc
--- ns-3.37/src/wave/model/wave-net-device.cc	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/wave-net-device.cc	2023-03-16 20:54:23.844869400 -0700
@@ -144,7 +144,7 @@
 WaveNetDevice::DoInitialize()
 {
     NS_LOG_FUNCTION(this);
-    if (m_phyEntities.size() == 0)
+    if (m_phyEntities.empty())
     {
         NS_FATAL_ERROR("there is no PHY entity in this WAVE device");
     }
@@ -153,7 +153,7 @@
         Ptr<WifiPhy> phy = (*i);
         phy->Initialize();
     }
-    if (m_macEntities.size() == 0)
+    if (m_macEntities.empty())
     {
         NS_FATAL_ERROR("there is no MAC entity in this WAVE device");
     }
@@ -469,7 +469,7 @@
 }
 
 void
-WaveNetDevice::CancelTx(uint32_t channelNumber, enum AcIndex ac)
+WaveNetDevice::CancelTx(uint32_t channelNumber, AcIndex ac)
 {
     if (IsAvailableChannel(channelNumber))
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/model/wave-net-device.h ns-3.38/src/wave/model/wave-net-device.h
--- ns-3.37/src/wave/model/wave-net-device.h	2022-11-01 17:37:24.731395700 -0700
+++ ns-3.38/src/wave/model/wave-net-device.h	2023-03-16 20:54:23.844869400 -0700
@@ -319,7 +319,7 @@
      *
      * Cancel all transmissions with the particular category and channel number.
      */
-    void CancelTx(uint32_t channelNumber, enum AcIndex ac);
+    void CancelTx(uint32_t channelNumber, AcIndex ac);
 
     /**
      * \param packet packet sent from above down to Network Device
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wave/test/ocb-test-suite.cc ns-3.38/src/wave/test/ocb-test-suite.cc
--- ns-3.37/src/wave/test/ocb-test-suite.cc	2022-11-01 17:37:24.735396000 -0700
+++ ns-3.38/src/wave/test/ocb-test-suite.cc	2023-03-16 20:54:23.848869300 -0700
@@ -108,7 +108,7 @@
                       Ptr<const Packet> packet,
                       double snr,
                       WifiMode mode,
-                      enum WifiPreamble preamble);
+                      WifiPreamble preamble);
     /**
      * Phy transmit trace function
      * \param context the context
@@ -233,7 +233,7 @@
                                  Ptr<const Packet> packet,
                                  double snr,
                                  WifiMode mode,
-                                 enum WifiPreamble preamble)
+                                 WifiPreamble preamble)
 {
     if (phyrx_time == Time(0))
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/CMakeLists.txt ns-3.38/src/wifi/CMakeLists.txt
--- ns-3.37/src/wifi/CMakeLists.txt	2022-11-01 17:37:24.735396000 -0700
+++ ns-3.38/src/wifi/CMakeLists.txt	2023-03-16 20:54:23.848869300 -0700
@@ -27,6 +27,9 @@
     model/edca-parameter-set.cc
     model/eht/eht-capabilities.cc
     model/eht/eht-configuration.cc
+    model/eht/eht-frame-exchange-manager.cc
+    model/eht/eht-operation.cc
+    model/eht/tid-to-link-mapping-element.cc
     model/eht/eht-phy.cc
     model/eht/eht-ppdu.cc
     model/eht/multi-link-element.cc
@@ -173,6 +176,9 @@
     model/edca-parameter-set.h
     model/eht/eht-capabilities.h
     model/eht/eht-configuration.h
+    model/eht/eht-frame-exchange-manager.h
+    model/eht/eht-operation.h
+    model/eht/tid-to-link-mapping-element.h
     model/eht/eht-phy.h
     model/eht/eht-ppdu.h
     model/eht/multi-link-element.h
@@ -335,9 +341,11 @@
     test/wifi-phy-reception-test.cc
     test/wifi-phy-thresholds-test.cc
     test/wifi-primary-channels-test.cc
+    test/wifi-ru-allocation-test.cc
     test/wifi-channel-switching-test.cc
     test/wifi-test.cc
     test/wifi-transmit-mask-test.cc
     test/wifi-txop-test.cc
     test/wifi-phy-cca-test.cc
+    test/wifi-non-ht-dup-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/reference/Bianchi11a.m ns-3.38/src/wifi/examples/reference/Bianchi11a.m
--- ns-3.37/src/wifi/examples/reference/Bianchi11a.m	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/reference/Bianchi11a.m	2023-03-16 20:54:23.852869300 -0700
@@ -40,7 +40,7 @@
 T_SYMBOL = 3.2e-6 + T_GI; % symbol duration in seconds
 T_LPHY = 20e-6; % PHY preamble & header duration in seconds
 L_SERVICE = 16; % service field length in bits
-L_TAIL = 6; % tail lengthh in bits
+L_TAIL = 6; % tail length in bits
 L_MAC = (24 + 4) * 8; % MAC header size in bits
 L_APP_HDR = 8 * 6; % bits added by the upper layer(s)
 T_SIFS = 16e-6;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/reference/bianchi11ax.py ns-3.38/src/wifi/examples/reference/bianchi11ax.py
--- ns-3.37/src/wifi/examples/reference/bianchi11ax.py	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/reference/bianchi11ax.py	2023-03-16 20:54:23.852869300 -0700
@@ -36,7 +36,7 @@
     T_PHY_ACK = 20e-6              # PHY preamble & header duration in seconds (for ACK)
     T_PHY_DATA = 44e-6             # PHY preamble & header duration in seconds (for DATA)
     L_SERVICE = 16                 # service field length in bits
-    L_TAIL = 6                     # tail lengthh in bits
+    L_TAIL = 6                     # tail length in bits
     L_MAC = (30) * 8               # MAC header size in bits
     L_APP_HDR = 8 * 8              # bits added by the upper layer(s)
     T_SIFS = 16e-6
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/reference/Bianchi11g.m ns-3.38/src/wifi/examples/reference/Bianchi11g.m
--- ns-3.37/src/wifi/examples/reference/Bianchi11g.m	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/reference/Bianchi11g.m	2023-03-16 20:54:23.852869300 -0700
@@ -41,7 +41,7 @@
 T_LPHY = 20e-6; % PHY preamble & header duration in seconds
 T_SIG_EXT = 6e-6; % signal extension duration in seconds
 L_SERVICE = 16; % service field length in bits
-L_TAIL = 6; % tail lengthh in bits
+L_TAIL = 6; % tail length in bits
 L_MAC = (24 + 4) * 8; % MAC header size in bits
 L_APP_HDR = 8 * 6; % bits added by the upper layer(s)
 T_SIFS = 10e-6;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/wifi-bianchi.cc ns-3.38/src/wifi/examples/wifi-bianchi.cc
--- ns-3.37/src/wifi/examples/wifi-bianchi.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/wifi-bianchi.cc	2023-03-16 20:54:23.852869300 -0700
@@ -76,14 +76,14 @@
 std::map<Mac48Address, uint64_t>
     packetsTransmitted; ///< Map that stores the total packets transmitted per STA
 std::map<Mac48Address, uint64_t>
-    psduFailed; ///< Map that stores the total number of unsuccessfully received PSDUS (for which
+    psduFailed; ///< Map that stores the total number of unsuccessfuly received PSDUS (for which
                 ///< the PHY header was successfully received)  per STA (including PSDUs not
                 ///< addressed to that STA)
 std::map<Mac48Address, uint64_t>
     psduSucceeded; ///< Map that stores the total number of successfully received PSDUs per STA
                    ///< (including PSDUs not addressed to that STA)
 std::map<Mac48Address, uint64_t> phyHeaderFailed; ///< Map that stores the total number of
-                                                  ///< unsuccessfully received PHY headers per STA
+                                                  ///< unsuccessfuly received PHY headers per STA
 std::map<Mac48Address, uint64_t>
     rxEventWhileTxing; ///< Map that stores the number of reception events per STA that occurred
                        ///< while PHY was already transmitting a PPDU
@@ -2532,10 +2532,10 @@
     MobilityHelper mobility;
     Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
     mobility.SetMobilityModel("ns3::ConstantPositionMobilityModel");
-    // Set postion for AP
+    // Set position for AP
     positionAlloc->Add(Vector(1.0, 1.0, 0.0));
 
-    // Set postion for STAs
+    // Set position for STAs
     double angle = (static_cast<double>(360) / (nNodes - 1));
     for (uint32_t i = 0; i < (nNodes - 1); ++i)
     {
@@ -2593,13 +2593,18 @@
                         MakeCallback(&DisassociationLog));
     }
 
+    std::string txop =
+        StaticCast<WifiNetDevice>(wifiNodes.Get(0)->GetDevice(0))->GetMac()->GetQosSupported()
+            ? "BE_Txop"
+            : "Txop";
     // Trace CW evolution
-    Config::Connect("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/$ns3::WifiMac/Txop/CwTrace",
+    Config::Connect("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/$ns3::WifiMac/" + txop +
+                        "/CwTrace",
                     MakeCallback(&CwTrace));
     // Trace backoff evolution
-    Config::Connect(
-        "/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/$ns3::WifiMac/Txop/BackoffTrace",
-        MakeCallback(&BackoffTrace));
+    Config::Connect("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/$ns3::WifiMac/" + txop +
+                        "/BackoffTrace",
+                    MakeCallback(&BackoffTrace));
     // Trace PHY Tx start events
     Config::Connect("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/$ns3::WifiPhy/PhyTxBegin",
                     MakeCallback(&PhyTxTrace));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/wifi-manager-example.cc ns-3.38/src/wifi/examples/wifi-manager-example.cc
--- ns-3.37/src/wifi/examples/wifi-manager-example.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/wifi-manager-example.cc	2023-03-16 20:54:23.852869300 -0700
@@ -25,6 +25,14 @@
 // The test consists of a device acting as server and a device as client generating traffic.
 //
 // The output consists of a plot of the rate observed and selected at the client device.
+// A special FixedRss propagation loss model is used to set a specific receive
+// power on the receiver.  The noise power is exclusively the thermal noise
+// for the channel bandwidth (no noise figure is configured).  Furthermore,
+// the CCA sensitivity attribute in WifiPhy can prevent signals from being
+// received even though the error model would permit it.  Therefore, for
+// the purpose of this example, the CCA sensitivity is lowered to a value
+// that disables it, and furthermore, the preamble detection model (which
+// also contains a similar threshold) is disabled.
 //
 // By default, the 802.11a standard using IdealWifiManager is plotted. Several command line
 // arguments can change the following options:
@@ -593,9 +601,24 @@
     Config::SetDefault("ns3::MinstrelWifiManager::PrintSamples", BooleanValue(true));
     Config::SetDefault("ns3::MinstrelHtWifiManager::PrintStats", BooleanValue(true));
 
+    // Disable the default noise figure of 7 dBm in WifiPhy; the calculations
+    // of SNR below assume that the only noise is thermal noise
+    Config::SetDefault("ns3::WifiPhy::RxNoiseFigure", DoubleValue(0));
+
+    // By default, the CCA sensitivity is -82 dBm, meaning if the RSS is
+    // below this value, the receiver will reject the Wi-Fi frame.
+    // However, we want to probe the error model down to low SNR values,
+    // and we have disabled the noise figure, so the noise level in 20 MHz
+    // will be about -101 dBm.  Therefore, lower the CCA sensitivity to a
+    // value that disables it (e.g. -110 dBm)
+    Config::SetDefault("ns3::WifiPhy::CcaSensitivity", DoubleValue(-110));
+
     WifiHelper wifi;
     wifi.SetStandard(serverSelectedStandard.m_standard);
     YansWifiPhyHelper wifiPhy;
+    // Disable the preamble detection model for the same reason that we
+    // disabled CCA sensitivity above-- we want to enable reception at low SNR
+    wifiPhy.DisablePreambleDetectionModel();
 
     Ptr<YansWifiChannel> wifiChannel = CreateObject<YansWifiChannel>();
     Ptr<ConstantSpeedPropagationDelayModel> delayModel =
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/wifi-phy-configuration.cc ns-3.38/src/wifi/examples/wifi-phy-configuration.cc
--- ns-3.37/src/wifi/examples/wifi-phy-configuration.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/wifi-phy-configuration.cc	2023-03-16 20:54:23.852869300 -0700
@@ -225,10 +225,10 @@
         staDevice = wifi.Install(phy, macSta, wifiStaNode.Get(0));
         apDevice = wifi.Install(phy, macAp, wifiApNode.Get(0));
         phySta = GetYansWifiPhyPtr(staDevice);
-        // We expect channel 7, width 80, frequency 5975
+        // We expect channel 7, width 80, frequency 5985
         NS_ASSERT(phySta->GetChannelNumber() == 7);
         NS_ASSERT(phySta->GetChannelWidth() == 80);
-        NS_ASSERT(phySta->GetFrequency() == 5975);
+        NS_ASSERT(phySta->GetFrequency() == 5985);
         PrintAttributesIfEnabled(printAttributes);
         break;
     case 10:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/wifi-phy-test.cc ns-3.38/src/wifi/examples/wifi-phy-test.cc
--- ns-3.37/src/wifi/examples/wifi-phy-test.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/wifi-phy-test.cc	2023-03-16 20:54:23.852869300 -0700
@@ -75,9 +75,9 @@
                  RxSignalInfo rxSignalInfo,
                  WifiTxVector txVector,
                  std::vector<bool> statusPerMpdu);
-    Ptr<WifiPhy> m_tx;      ///< transmit
-    struct Input m_input;   ///< input
-    struct Output m_output; ///< output
+    Ptr<WifiPhy> m_tx; ///< transmit
+    Input m_input;     ///< input
+    Output m_output;   ///< output
 };
 
 void
@@ -175,7 +175,7 @@
         uint32_t nPackets;     ///< number of packets
     };
 
-    /// Output struture
+    /// Output structure
     struct Output
     {
         uint32_t receivedA; ///< received A
@@ -207,12 +207,12 @@
                  RxSignalInfo rxSignalInfo,
                  WifiTxVector txVector,
                  std::vector<bool> statusPerMpdu);
-    Ptr<WifiPhy> m_txA;     ///< transmit A
-    Ptr<WifiPhy> m_txB;     ///< transmit B
-    uint32_t m_flowIdA;     ///< flow ID A
-    uint32_t m_flowIdB;     ///< flow ID B
-    struct Input m_input;   ///< input
-    struct Output m_output; ///< output
+    Ptr<WifiPhy> m_txA; ///< transmit A
+    Ptr<WifiPhy> m_txB; ///< transmit B
+    uint32_t m_flowIdA; ///< flow ID A
+    uint32_t m_flowIdB; ///< flow ID B
+    Input m_input;      ///< input
+    Output m_output;    ///< output
 };
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/examples/wifi-test-interference-helper.cc ns-3.38/src/wifi/examples/wifi-test-interference-helper.cc
--- ns-3.37/src/wifi/examples/wifi-test-interference-helper.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/examples/wifi-test-interference-helper.cc	2023-03-16 20:54:23.852869300 -0700
@@ -71,9 +71,9 @@
 
 NS_LOG_COMPONENT_DEFINE("test-interference-helper");
 
-bool checkResults = false;         //!< True if results have to be checked.
-bool expectRxASuccessfull = false; //!< True if Rx from A is expected to be successful.
-bool expectRxBSuccessfull = false; //!< True if Rx from B is expected to be successful.
+bool checkResults = false;        //!< True if results have to be checked.
+bool expectRxASuccessful = false; //!< True if Rx from A is expected to be successful.
+bool expectRxBSuccessful = false; //!< True if Rx from B is expected to be successful.
 
 /// InterferenceExperiment
 class InterferenceExperiment
@@ -123,7 +123,7 @@
     void SendB() const;
     Ptr<SpectrumWifiPhy> m_txA; ///< transmit A function
     Ptr<SpectrumWifiPhy> m_txB; ///< transmit B function
-    struct Input m_input;       ///< input
+    Input m_input;              ///< input
     bool m_droppedA;            ///< flag to indicate whether packet A has been dropped
     bool m_droppedB;            ///< flag to indicate whether packet B has been dropped
     mutable uint64_t m_uidA;    ///< UID to use for packet A
@@ -307,7 +307,7 @@
     m_txA->Dispose();
     rx->Dispose();
 
-    if (checkResults && (m_droppedA == expectRxASuccessfull || m_droppedB == expectRxBSuccessfull))
+    if (checkResults && (m_droppedA == expectRxASuccessful || m_droppedB == expectRxBSuccessful))
     {
         NS_LOG_ERROR("Results are not expected!");
         exit(1);
@@ -344,12 +344,12 @@
     cmd.AddValue("enableCapture", "Enable/disable physical layer capture", input.captureEnabled);
     cmd.AddValue("captureMargin", "Margin used for physical layer capture", input.captureMargin);
     cmd.AddValue("checkResults", "Used to check results at the end of the test", checkResults);
-    cmd.AddValue("expectRxASuccessfull",
+    cmd.AddValue("expectRxASuccessful",
                  "Indicate whether packet A is expected to be successfully received",
-                 expectRxASuccessfull);
-    cmd.AddValue("expectRxBSuccessfull",
+                 expectRxASuccessful);
+    cmd.AddValue("expectRxBSuccessful",
                  "Indicate whether packet B is expected to be successfully received",
-                 expectRxBSuccessfull);
+                 expectRxBSuccessful);
     cmd.Parse(argc, argv);
 
     input.interval = MicroSeconds(delay);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/helper/wifi-helper.cc ns-3.38/src/wifi/helper/wifi-helper.cc
--- ns-3.37/src/wifi/helper/wifi-helper.cc	2022-11-01 17:37:24.739395900 -0700
+++ ns-3.38/src/wifi/helper/wifi-helper.cc	2023-03-16 20:54:23.852869300 -0700
@@ -798,10 +798,20 @@
         std::vector<Ptr<WifiRemoteStationManager>> managers;
         std::vector<Ptr<WifiPhy>> phys = phyHelper.Create(node, device);
         device->SetPhys(phys);
+        // if only one remote station manager model was provided, replicate it for all the links
+        auto stationManagers = m_stationManager;
+        if (stationManagers.size() == 1 && phys.size() > 1)
+        {
+            stationManagers.resize(phys.size(), stationManagers[0]);
+        }
+        NS_ABORT_MSG_IF(stationManagers.size() != phys.size(),
+                        "Number of station manager models ("
+                            << stationManagers.size() << ") does not match the number of links ("
+                            << phys.size() << ")");
         for (std::size_t i = 0; i < phys.size(); i++)
         {
             phys[i]->ConfigureStandard(m_standard);
-            managers.push_back(m_stationManager.Create<WifiRemoteStationManager>());
+            managers.push_back(stationManagers[i].Create<WifiRemoteStationManager>());
         }
         device->SetRemoteStationManagers(managers);
         Ptr<WifiMac> mac = macHelper.Create(device, m_standard);
@@ -890,6 +900,7 @@
     LogComponentEnable("DsssErrorRateModel", LOG_LEVEL_ALL);
     LogComponentEnable("DsssPhy", LOG_LEVEL_ALL);
     LogComponentEnable("DsssPpdu", LOG_LEVEL_ALL);
+    LogComponentEnable("EhtFrameExchangeManager", LOG_LEVEL_ALL);
     LogComponentEnable("ErpOfdmPhy", LOG_LEVEL_ALL);
     LogComponentEnable("ErpOfdmPpdu", LOG_LEVEL_ALL);
     LogComponentEnable("EhtPhy", LOG_LEVEL_ALL);
